# data is a s2dv_cube object
# units as character
units_transform <- function(data, orig_units, user_units) {
  if (orig_units %in% c("C", "k")) {
    if (user_units %in% c("C", "k")) {
      trans <- transform_units_temperature(data, orig_units, user_units)
    } else {
      stop("Transformation temperature units not available.")
  } if  else (orig_units %in% c("ms-1", "kgm-2s-1", "mm", "m")) {
    if (user_units %in% c("ms-1", "kgm-2s-1", "mm", "m")) {
      trans <- transform_units_precipitation(data, orig_units, user_units)
    } else {
      stop("Transformation precipitation units not available.")
    }
  } if else (orig_units %in% c("pa", "hpa", "mb")) {
     if (user_units %in% c("ms-1", "kgm-2s-1", "mm", "m")) {
      trans <- transform_units_pressure(data, orig_units, user_units)
    } else {
      stop("Transformation precipitation units not available.")
    }
  } else {
     stop("Transformation unknown.")
  }
}

