# This function aims to convert units
## 
source("modules/R/units_transform.R")
source("modules/R/transform_units_temperature.R")
source("modules/R/transform_units_precipitation.R")
source("modules/R/transform_units_preasure.R")
Units <- function(recipe, data) {
  # from recipe read the user defined units
  # from data the original units
  # deaccumulate option for CDS accumulated variables?
  ## Do we need to convert other than ECVs?
  user_units <- recipe$Analysis$Variables$units 
  var_names <- lapply(data, function(x) {x$attrs$Variable$varName})
  orig_units <- lapply(1:length(data), function(x) {
                  data[[x]]$attrs$Variable$metadata[[var_names[[x]]]]$units})
  # remove spaces, "**", "*" and "per" from units
  user_units <- tolower(user_units) 
  user_units <- gsub(" ", "", user_units)
  user_units <- gsub("**", "", user_units)
  user_units <- gsub("*", "", user_units)
  orig_units <- lapply(orig_units, function(x) {
                       x <- tolower(x)
                       x <- gsub(" ", "", x)
                       x <- gsub("**", "", x)
                       x <- gsub("*", "", x)}) 
  # if "/" appears substitute by -1 in at the end of next unit. How to know?

  if (all(orig_units == user_units)) {  
    # no transformation needed
    res <- data
  } else { 
    obj2trans <- which(orig_units != user_units)
    res <- lapply(1:length(data), function(x) {
                  if (x %in% obj2trans) {
                    result <- units_transform(data[x], 
                                              orig_units = orig_units[x],
                                              user_units = user_units)
                  } else {
                    result <- data[x]
                  }
                  return(result)
                  })
  }
  return(res)
}
